#!/usr/bin/perl

use strict;
use rsplib;

sub serverTest() {
	my $node = new rsplib::RSP_server("127.0.0.1", 3497, 5, 0);

	$node->useSSL("./perltest.rsa");
	$node->connect();
	
	my $module;
	while(defined($module = $node->nextServerModule())) {
		print "Name = \"" . $module->getName() . "\", Data = \"" .
			$module->getData() . "\", Thresh = \"" . $module->threshold() . "\"\n";
	}
}

sub parseTest() {
	my $pd = new rsplib::RSP_parseData("127.0.0.1", 3496, 30);

	my @hosts;
	my @modules;

	$pd->getHostsAndModules(\@hosts, \@modules);

	print "Hosts:\n";
	foreach my $host (@hosts) {
		print $host . "\n";
	}

	print "\nModules:\n";
	foreach my $module (@modules) {
		print $module . "\n";
	}

	my @keys;

	$pd->getKeys("euclid", "CPUInfo", \@keys);

	print "\nKeys:\n";
	foreach my $key (@keys) {
		print $key . "\n";
	}

	$pd->begin("euclid", "CPUInfo", "idle", -1, -1, 0);

	my $line;
	while(defined($line = $pd->next())) {
		print $line->getData() . "\n";
	}
}

#serverTest();
parseTest();
